Index: inc/core/class.dc.core.php
===================================================================
--- inc/core/class.dc.core.php	(revision 873)
+++ inc/core/class.dc.core.php	(revision 706)
@@ -35,4 +35,6 @@
 	public $wiki2xhtml;	///< <b>wiki2xhtml</b>		wiki2xhtml object
 	public $plugins;	///< <b>dcModules</b>		dcModules object
+	public $media;		///< <b>dcMedia</b>			dcMedia object
+	public $postmedia;	///< <b>dcPostMedia</b>		dcPostMedia object
 	public $rest;		///< <b>dcRestServer</b>	dcRestServer object
 	public $log;		///< <b>dcLog</b>			dcLog object
@@ -371,8 +373,8 @@
 		{
 			$strReq = 'SELECT module, version FROM '.$this->prefix.'version';
-			$modules = $this->con->select($strReq);
+			$rs = $this->con->select($strReq);
 			
-			foreach ($modules as $m) {
-				$this->versions[$m->module] = $m->version;
+			while ($rs->fetch()) {
+				$this->versions[$rs->module] = $rs->version;
 			}
 		}
@@ -506,7 +508,7 @@
 		}
 		
-		$users = $this->con->select($strReq);
-		$users->extend('rsExtUser');
-		return $users;
+		$rs = $this->con->select($strReq);
+		$rs->extend('rsExtUser');
+		return $rs;
 	}
 	
@@ -569,11 +571,11 @@
 		
 		# Updating all user's blogs
-		$blogs = $this->con->select(
+		$rs = $this->con->select(
 			'SELECT DISTINCT(blog_id) FROM '.$this->prefix.'post '.
 			"WHERE user_id = '".$this->con->escape($id)."' "
 			);
 		
-		foreach ($blogs as $blog) {
-			$b = new dcBlog($this,$blog->blog_id);
+		while ($rs->fetch()) {
+			$b = new dcBlog($this,$rs->blog_id);
 			$b->triggerBlog();
 			unset($b);
@@ -598,7 +600,7 @@
 		}
 		
-		$user = $this->getUser($id);
-		
-		if ($user->nb_post > 0) {
+		$rs = $this->getUser($id);
+		
+		if ($rs->nb_post > 0) {
 			return;
 		}
@@ -624,7 +626,7 @@
 				"WHERE user_id = '".$this->con->escape($id)."' ";
 		
-		$users = $this->con->select($strReq);
-		
-		return (count($users) > 0);
+		$rs = $this->con->select($strReq);
+		
+		return !$rs->isEmpty();
 	}
 	
@@ -649,14 +651,14 @@
 				"WHERE user_id = '".$this->con->escape($id)."' ";
 		
-		$blogs = $this->con->select($strReq);
+		$rs = $this->con->select($strReq);
 		
 		$res = array();
 		
-		foreach ($blogs as $blog)
+		while ($rs->fetch())
 		{
-			$res[$blog->blog_id] = array(
-				'name' => $blog->blog_name,
-				'url' => $blog->blog_url,
-				'p' => $this->auth->parsePermissions($blog->permissions)
+			$res[$rs->blog_id] = array(
+				'name' => $rs->blog_name,
+				'url' => $rs->blog_url,
+				'p' => $this->auth->parsePermissions($rs->permissions)
 			);
 		}
@@ -829,16 +831,16 @@
 		}
 		
-		$users = $this->con->select($strReq);
+		$rs = $this->con->select($strReq);
 		
 		$res = array();
 		
-		foreach ($users as $u)
+		while ($rs->fetch())
 		{
-			$res[$u->user_id] = array(
-				'name' => $u->user_name,
-				'firstname' => $u->user_firstname,
-				'displayname' => $u->user_displayname,
-				'super' => (boolean) $u->user_super,
-				'p' => $this->auth->parsePermissions($u->permissions)
+			$res[$rs->user_id] = array(
+				'name' => $rs->user_name,
+				'firstname' => $rs->user_firstname,
+				'displayname' => $rs->user_displayname,
+				'super' => (boolean) $rs->user_super,
+				'p' => $this->auth->parsePermissions($rs->permissions)
 			);
 		}
@@ -1025,7 +1027,7 @@
 				"WHERE blog_id = '".$this->con->escape($id)."' ";
 		
-		$blogs = $this->con->select($strReq);
-		
-		return (count($blogs) > 0);
+		$rs = $this->con->select($strReq);
+		
+		return !$rs->isEmpty();
 	}
 	
@@ -1139,4 +1141,84 @@
 	}
 	
+	/**
+	Inits <var>wiki2xhtml</var> property for simple blog comment (basic syntax).
+	*/
+	public function initWikiSimpleComment()
+	{
+		$this->initWiki();
+		
+		$this->wiki2xhtml->setOpts(array(
+			'active_title' => 0,
+			'active_setext_title' => 0,
+			'active_hr' => 0,
+			'active_lists' => 0,
+			'active_quote' => 0,
+			'active_pre' => 0,
+			'active_empty' => 0,
+			'active_auto_br' => 1,
+			'active_auto_urls' => 1,
+			'active_urls' => 0,
+			'active_auto_img' => 0,
+			'active_img' => 0,
+			'active_anchor' => 0,
+			'active_em' => 0,
+			'active_strong' => 0,
+			'active_br' => 0,
+			'active_q' => 0,
+			'active_code' => 0,
+			'active_acronym' => 0,
+			'active_ins' => 0,
+			'active_del' => 0,
+			'active_footnotes' => 0,
+			'active_wikiwords' => 0,
+			'active_macros' => 0,
+			'parse_pre' => 0,
+			'active_fr_syntax' => 0
+		));
+		
+		# --BEHAVIOR-- coreInitWikiSimpleComment
+		$this->callBehavior('coreInitWikiSimpleComment',$this->wiki2xhtml);
+	}
+	
+	/**
+	Inits <var>wiki2xhtml</var> property for blog comment.
+	*/
+	public function initWikiComment()
+	{
+		$this->initWiki();
+		
+		$this->wiki2xhtml->setOpts(array(
+			'active_title' => 0,
+			'active_setext_title' => 0,
+			'active_hr' => 0,
+			'active_lists' => 1,
+			'active_quote' => 0,
+			'active_pre' => 1,
+			'active_empty' => 0,
+			'active_auto_br' => 1,
+			'active_auto_urls' => 1,
+			'active_urls' => 1,
+			'active_auto_img' => 0,
+			'active_img' => 0,
+			'active_anchor' => 0,
+			'active_em' => 1,
+			'active_strong' => 1,
+			'active_br' => 1,
+			'active_q' => 1,
+			'active_code' => 1,
+			'active_acronym' => 1,
+			'active_ins' => 1,
+			'active_del' => 1,
+			'active_footnotes' => 0,
+			'active_wikiwords' => 0,
+			'active_macros' => 0,
+			'parse_pre' => 0,
+			'active_fr_syntax' => 0
+		));
+		
+		# --BEHAVIOR-- coreInitWikiComment
+		$this->callBehavior('coreInitWikiComment',$this->wiki2xhtml);
+	}
+	
 	public function wikiPostLink($url,$content)
 	{
@@ -1187,6 +1269,16 @@
 		{
 			$defaults = array(
+				array('allow_comments','boolean',true,
+				'Allow comments on blog'),
+				array('allow_trackbacks','boolean',true,
+				'Allow trackbacks on blog'),
 				array('blog_timezone','string','Europe/London',
 				'Blog timezone'),
+				array('comments_nofollow','boolean',true,
+				'Add rel="nofollow" to comments URLs'),
+				array('comments_pub','boolean',true,
+				'Publish comments immediately'),
+				array('comments_ttl','integer',0,
+				'Number of days to keep comments open (0 means no ttl)'),
 				array('copyright_notice','string','','Copyright notice (simple text)'),
 				array('date_format','string','%A, %B %e %Y',
@@ -1200,8 +1292,20 @@
 				array('lang','string','en',
 				'Default blog language'),
+				array('media_exclusion','string','/\.php$/i',
+				'File name exclusion pattern in media manager. (PCRE value)'),
+				array('media_img_m_size','integer',448,
+				'Image medium size in media manager'),
+				array('media_img_s_size','integer',240,
+				'Image small size in media manager'),
+				array('media_img_t_size','integer',100,
+				'Image thumbnail size in media manager'),
+				array('media_img_title_pattern','string','Title ;; Date(%b %Y) ;; separator(, )',
+				'Pattern to set image title when you insert it in a post'),
 				array('nb_post_per_page','integer',20,
 				'Number of entries on home page and category pages'),
 				array('nb_post_per_feed','integer',20,
 				'Number of entries on feeds'),
+				array('nb_comment_per_feed','integer',20,
+				'Number of comments on feeds'),
 				array('post_url_format','string','{y}/{m}/{d}/{t}',
 				'Post URL format. {y}: year, {m}: month, {d}: day, {id}: post id, {t}: entry title'),
@@ -1226,8 +1330,14 @@
 				array('tpl_use_cache','boolean',true,
 				'Use template caching'),
+				array('trackbacks_pub','boolean',true,
+				'Publish trackbacks immediately'),
+				array('trackbacks_ttl','integer',0,
+				'Number of days to keep trackbacks open (0 means no ttl)'),
 				array('url_scan','string','query_string',
 				'URL handle mode (path_info or query_string)'),
 				array('use_smilies','boolean',false,
 				'Show smilies on entries and comments'),
+				array('wiki_comments','boolean',false,
+				'Allow commenters to use a subset of wiki syntax')
 			);
 		}
@@ -1253,7 +1363,6 @@
 		$strReq = 'SELECT COUNT(post_id) '.
 				'FROM '.$this->prefix.'post';
-		$count = $this->con->select($strReq);
-		$count = $count->current();
-		$count = $count->f(0);
+		$rs = $this->con->select($strReq);
+		$count = $rs->f(0);
 		
 		$strReq = 'SELECT post_id, post_title, post_excerpt_xhtml, post_content_xhtml '.
@@ -1264,15 +1373,15 @@
 		}
 		
-		$posts = $this->con->select($strReq,true);
+		$rs = $this->con->select($strReq,true);
 		
 		$cur = $this->con->openCursor($this->prefix.'post');
 		
-		foreach ($posts as $post)
+		while ($rs->fetch())
 		{
-			$words = $post->post_title.' '.	$post->post_excerpt_xhtml.' '.
-			$post->post_content_xhtml;
+			$words = $rs->post_title.' '.	$rs->post_excerpt_xhtml.' '.
+			$rs->post_content_xhtml;
 			
 			$cur->post_words = implode(' ',text::splitWords($words));
-			$cur->update('WHERE post_id = '.(integer) $post->post_id);
+			$cur->update('WHERE post_id = '.(integer) $rs->post_id);
 			$cur->clean();
 		}
@@ -1282,4 +1391,65 @@
 		}
 		return $start+$limit;
+	}
+	
+	/**
+	Recreates comments search engine index.
+	
+	@param	start	<b>integer</b>		Start comment index
+	@param	limit	<b>integer</b>		Number of comments to index
+	
+	@return	<b>integer</b>		<var>$start</var> and <var>$limit</var> sum
+	*/
+	public function indexAllComments($start=null,$limit=null)
+	{
+		$strReq = 'SELECT COUNT(comment_id) '.
+				'FROM '.$this->prefix.'comment';
+		$rs = $this->con->select($strReq);
+		$count = $rs->f(0);
+		
+		$strReq = 'SELECT comment_id, comment_content '.
+				'FROM '.$this->prefix.'comment ';
+		
+		if ($start !== null && $limit !== null) {
+			$strReq .= $this->con->limit($start,$limit);
+		}
+		
+		$rs = $this->con->select($strReq);
+		
+		$cur = $this->con->openCursor($this->prefix.'comment');
+		
+		while ($rs->fetch())
+		{
+			$cur->comment_words = implode(' ',text::splitWords($rs->comment_content));
+			$cur->update('WHERE comment_id = '.(integer) $rs->comment_id);
+			$cur->clean();
+		}
+		
+		if ($start+$limit > $count) {
+			return null;
+		}
+		return $start+$limit;
+	}
+	
+	/**
+	Reinits nb_comment and nb_trackback in post table.
+	*/
+	public function countAllComments()
+	{
+	
+		$updCommentReq = 'UPDATE '.$this->prefix.'post P '.
+			'SET nb_comment = ('.
+				'SELECT COUNT(C.comment_id) from '.$this->prefix.'comment C '.
+				'WHERE C.post_id = P.post_id AND C.comment_trackback <> 1 '.
+				'AND C.comment_status = 1 '.
+			')';
+		$updTrackbackReq = 'UPDATE '.$this->prefix.'post P '.
+			'SET nb_trackback = ('.
+				'SELECT COUNT(C.comment_id) from '.$this->prefix.'comment C '.
+				'WHERE C.post_id = P.post_id AND C.comment_trackback = 1 '.
+				'AND C.comment_status = 1 '.
+			')';
+		$this->con->execute($updCommentReq);
+		$this->con->execute($updTrackbackReq);
 	}
 	
